package tools.descartes.dql.connector.kieker.structures;

import java.util.HashSet;
import java.util.Set;

import tools.descartes.dql.connector.kieker.structures.identifier.ComponentIdentifier;

public class Component {
	
	private Set<ComponentIdentifier> componentIdentifiers;
	private String name;
	
	public Component(String name) {
		this.componentIdentifiers = new HashSet<ComponentIdentifier>();
		this.name = name;
	}
	
	public void addComponentIdentifier(ComponentIdentifier componentIdentifier){
		componentIdentifiers.add(componentIdentifier);
	}
	
	public Set<ComponentIdentifier> getComponentIdentifiers() {
		return componentIdentifiers;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String toString(){
		return "Component \"" + name + "\":\n" + componentIdentifiers.toString();
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Component other = (Component) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	
	

}
